package com.example.johannes.bluetoothtestapp;

import android.bluetooth.BluetoothSocket;
import android.os.AsyncTask;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class manageconnection_bt extends Thread {
        private final BluetoothSocket mmSocket;
        private final InputStream mmInStream;
        private final OutputStream mmOutStream;
        private final Handler myHandler_get;
        private byte[] readBuffer;
        private int readBufferPosition;
        private Thread receive;

        public manageconnection_bt(BluetoothSocket socket, Handler myHandler) {
            InputStream tmpIn = null;
            OutputStream tmpOut = null;

            try {
                tmpIn = socket.getInputStream();
                tmpOut = socket.getOutputStream();
            } catch (IOException e) {Log.e("Bluetooth", "Fehler beim übernehmen des Streams");}

            mmInStream = tmpIn;
            mmOutStream = tmpOut;
            mmSocket = socket;
            myHandler_get = myHandler;
        }
        public void run() {
            final byte delimiter = 10; //This is the ASCII code for a newline character

            readBufferPosition = 0;
            readBuffer = new byte[1024];
            receive = new Thread(new Runnable() {
                @Override
                public void run() {
                    while (true) {
                        try {
                            int bytesAvailable = mmInStream.available();
                            if (bytesAvailable > 0) {
                                byte[] packetBytes = new byte[bytesAvailable];
                                mmInStream.read(packetBytes);
                                for (int i = 0; i < bytesAvailable; i++) {
                                    byte b = packetBytes[i];
                                    if (b == delimiter) {
                                        byte[] encodedBytes = new byte[readBufferPosition];
                                        System.arraycopy(readBuffer, 0, encodedBytes, 0, encodedBytes.length);
                                        final String data = new String(encodedBytes, "US-ASCII");
                                        readBufferPosition = 0;
                                        Log.e("Daten empfangen:", data);

                                        Message msg = Message.obtain();
                                        msg.obj = data;
                                        myHandler_get.sendMessage(msg);
                                    } else {
                                        readBuffer[readBufferPosition++] = b;
                                    }
                                }
                            }
                        } catch (Exception e) {
                            Log.e("BLUETOOTH", "Fehler beim Empfangen:", e);
                        }
                    }
                }
            });
            receive.run();
        }


        /* Call this from the main activity to send data to the remote device */
        public void write(String bytes) {
            try {
                mmOutStream.write(bytes.getBytes());
            } catch (IOException e) {}
        }
        public void close() {
            try {
                mmSocket.close();
                receive.isInterrupted();
            } catch (IOException e) {
                e.printStackTrace();
            }
            receive.interrupt();
        }
    }

